# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables

class PersistenceProfileCookie(pulumi.CustomResource):
    always_send: pulumi.Output[str]
    """
    To enable _ disable always sending cookies
    """
    app_service: pulumi.Output[str]
    cookie_encryption: pulumi.Output[str]
    """
    To required, preferred, or disabled policy for cookie encryption
    """
    cookie_encryption_passphrase: pulumi.Output[str]
    """
    Passphrase for encrypted cookies
    """
    cookie_name: pulumi.Output[str]
    """
    Name of the cookie to track persistence
    """
    defaults_from: pulumi.Output[str]
    """
    Inherit defaults from parent profile
    """
    expiration: pulumi.Output[str]
    """
    Expiration TTL for cookie specified in D:H:M:S or in seconds
    """
    hash_length: pulumi.Output[float]
    """
    Length of hash to apply to cookie
    """
    hash_offset: pulumi.Output[float]
    """
    Number of characters to skip in the cookie for the hash
    """
    httponly: pulumi.Output[str]
    """
    To enable _ disable sending only over http
    """
    match_across_pools: pulumi.Output[str]
    """
    To enable _ disable match across pools with given persistence record
    """
    match_across_services: pulumi.Output[str]
    """
    To enable _ disable match across services with given persistence record
    """
    match_across_virtuals: pulumi.Output[str]
    """
    To enable _ disable match across virtual servers with given persistence record
    """
    mirror: pulumi.Output[str]
    """
    To enable _ disable
    """
    name: pulumi.Output[str]
    """
    Name of the persistence profile
    """
    override_conn_limit: pulumi.Output[str]
    """
    To enable _ disable that pool member connection limits are overridden for persisted clients. Per-virtual connection
    limits remain hard limits and are not overridden.
    """
    timeout: pulumi.Output[float]
    """
    Timeout for persistence of the session
    """
    def __init__(__self__, resource_name, opts=None, always_send=None, app_service=None, cookie_encryption=None, cookie_encryption_passphrase=None, cookie_name=None, defaults_from=None, expiration=None, hash_length=None, hash_offset=None, httponly=None, match_across_pools=None, match_across_services=None, match_across_virtuals=None, mirror=None, name=None, override_conn_limit=None, timeout=None, __props__=None, __name__=None, __opts__=None):
        """
        Create a PersistenceProfileCookie resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] always_send: To enable _ disable always sending cookies
        :param pulumi.Input[str] cookie_encryption: To required, preferred, or disabled policy for cookie encryption
        :param pulumi.Input[str] cookie_encryption_passphrase: Passphrase for encrypted cookies
        :param pulumi.Input[str] cookie_name: Name of the cookie to track persistence
        :param pulumi.Input[str] defaults_from: Inherit defaults from parent profile
        :param pulumi.Input[str] expiration: Expiration TTL for cookie specified in D:H:M:S or in seconds
        :param pulumi.Input[float] hash_length: Length of hash to apply to cookie
        :param pulumi.Input[float] hash_offset: Number of characters to skip in the cookie for the hash
        :param pulumi.Input[str] httponly: To enable _ disable sending only over http
        :param pulumi.Input[str] match_across_pools: To enable _ disable match across pools with given persistence record
        :param pulumi.Input[str] match_across_services: To enable _ disable match across services with given persistence record
        :param pulumi.Input[str] match_across_virtuals: To enable _ disable match across virtual servers with given persistence record
        :param pulumi.Input[str] mirror: To enable _ disable
        :param pulumi.Input[str] name: Name of the persistence profile
        :param pulumi.Input[str] override_conn_limit: To enable _ disable that pool member connection limits are overridden for persisted clients. Per-virtual connection
               limits remain hard limits and are not overridden.
        :param pulumi.Input[float] timeout: Timeout for persistence of the session
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['always_send'] = always_send
            __props__['app_service'] = app_service
            __props__['cookie_encryption'] = cookie_encryption
            __props__['cookie_encryption_passphrase'] = cookie_encryption_passphrase
            __props__['cookie_name'] = cookie_name
            if defaults_from is None:
                raise TypeError("Missing required property 'defaults_from'")
            __props__['defaults_from'] = defaults_from
            __props__['expiration'] = expiration
            __props__['hash_length'] = hash_length
            __props__['hash_offset'] = hash_offset
            __props__['httponly'] = httponly
            __props__['match_across_pools'] = match_across_pools
            __props__['match_across_services'] = match_across_services
            __props__['match_across_virtuals'] = match_across_virtuals
            __props__['mirror'] = mirror
            if name is None:
                raise TypeError("Missing required property 'name'")
            __props__['name'] = name
            __props__['override_conn_limit'] = override_conn_limit
            __props__['timeout'] = timeout
        super(PersistenceProfileCookie, __self__).__init__(
            'f5bigip:ltm/persistenceProfileCookie:PersistenceProfileCookie',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, always_send=None, app_service=None, cookie_encryption=None, cookie_encryption_passphrase=None, cookie_name=None, defaults_from=None, expiration=None, hash_length=None, hash_offset=None, httponly=None, match_across_pools=None, match_across_services=None, match_across_virtuals=None, mirror=None, name=None, override_conn_limit=None, timeout=None):
        """
        Get an existing PersistenceProfileCookie resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] always_send: To enable _ disable always sending cookies
        :param pulumi.Input[str] cookie_encryption: To required, preferred, or disabled policy for cookie encryption
        :param pulumi.Input[str] cookie_encryption_passphrase: Passphrase for encrypted cookies
        :param pulumi.Input[str] cookie_name: Name of the cookie to track persistence
        :param pulumi.Input[str] defaults_from: Inherit defaults from parent profile
        :param pulumi.Input[str] expiration: Expiration TTL for cookie specified in D:H:M:S or in seconds
        :param pulumi.Input[float] hash_length: Length of hash to apply to cookie
        :param pulumi.Input[float] hash_offset: Number of characters to skip in the cookie for the hash
        :param pulumi.Input[str] httponly: To enable _ disable sending only over http
        :param pulumi.Input[str] match_across_pools: To enable _ disable match across pools with given persistence record
        :param pulumi.Input[str] match_across_services: To enable _ disable match across services with given persistence record
        :param pulumi.Input[str] match_across_virtuals: To enable _ disable match across virtual servers with given persistence record
        :param pulumi.Input[str] mirror: To enable _ disable
        :param pulumi.Input[str] name: Name of the persistence profile
        :param pulumi.Input[str] override_conn_limit: To enable _ disable that pool member connection limits are overridden for persisted clients. Per-virtual connection
               limits remain hard limits and are not overridden.
        :param pulumi.Input[float] timeout: Timeout for persistence of the session
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["always_send"] = always_send
        __props__["app_service"] = app_service
        __props__["cookie_encryption"] = cookie_encryption
        __props__["cookie_encryption_passphrase"] = cookie_encryption_passphrase
        __props__["cookie_name"] = cookie_name
        __props__["defaults_from"] = defaults_from
        __props__["expiration"] = expiration
        __props__["hash_length"] = hash_length
        __props__["hash_offset"] = hash_offset
        __props__["httponly"] = httponly
        __props__["match_across_pools"] = match_across_pools
        __props__["match_across_services"] = match_across_services
        __props__["match_across_virtuals"] = match_across_virtuals
        __props__["mirror"] = mirror
        __props__["name"] = name
        __props__["override_conn_limit"] = override_conn_limit
        __props__["timeout"] = timeout
        return PersistenceProfileCookie(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

